import iio
from infer import InferenceHelper
import torch
import matplotlib.pyplot as plt
import cv2

import os
import sys
# Pre-downloaded weights from torchvision are in $bin
os.environ['TORCH_HOME'] = os.environ['bin']

# Used only for the dry run for the IPOL demo system
if sys.argv[2] == 'adabin/test_imgs/classroom__rgb_00283.jpg':
    os.environ['TORCH_HOME'] = './'

infer_helper = InferenceHelper(dataset='nyu', path=sys.argv[1])

# predict depth of a single pillow image
img = iio.read(sys.argv[2])/255.  # any rgb pillow image
#img = cv2.resize(img_, (640, 480))/255
img = torch.tensor(img).permute(2,0,1).unsqueeze(0)
bin_centers, predicted_depth = infer_helper.predict(img)

resized_pred = predicted_depth[0,0,...]
#resized_pred = cv2.resize(predicted_depth[0,0,...], img_.shape[:2])

#iio.write(sys.argv[3]+".tif", predicted_depth[0,0,...])
#plt.imsave(sys.argv[3]+'.png', -predicted_depth[0][0], cmap='inferno')

iio.write(sys.argv[3]+".tif", resized_pred)
plt.imsave(sys.argv[3]+'.png', -resized_pred, cmap='inferno')

